indexing

	description: "Various string routines."

	author: "Berend de Boer"
	copyright: "(c) 2003, Eiffel Forum License v2, see forum.txt"


class

	STRING_ROUTINES


feature -- Routines

	split_on (s: STRING; on: CHARACTER): ARRAY [STRING] is
			-- Split `s' on a given character `on'.
			-- s = Void is treated as s.is_empty, in that case the Result
			-- doesn't contain any entries.
		local
			p, start: INTEGER
			tmp_string: STRING
			count: INTEGER
			large_array: ARRAY [STRING]
			i: INTEGER
		do
			if s /= Void and then not s.is_empty then
				-- attempt to avoid allocs
				create Result.make (0, 32)
				from
					start := 1
					p := s.index_of (on, start)
				variant
					(s.count + 1) - start
				until
					p = 0
				loop
					tmp_string := s.substring (start, p-1)
					Result.force (tmp_string, count)
					count := count + 1
					start := p + 1
					p := s.index_of (on, start)
				end

				if start <= s.count then
					tmp_string := s.substring (start, s.count)
					Result.force (tmp_string, count)
					count := count + 1
				elseif start = s.count + 1 then
					-- make sure that when ended with `on' we append an
					-- empty string
					Result.force ("", count)
					count := count + 1
				end
				Result.resize (0, count-1)
				-- The following code covers the case where ARRAY.resize
				-- is not ELKS conformant.
				if Result.upper /= count - 1 then
					large_array := Result
					create Result.make (0, count - 1)
					from
						i := 0
					until
						i > count - 1
					loop
						Result.put (large_array.item (i), i)
						i := i + 1
					end
				end
			else
				create Result.make (0, -1)
			end
		ensure
			array_empty_if_s_empty:
				(s = Void implies Result.count = 0) and
				(s.is_empty implies Result.count = 0)
			got_all_parts:
				s /= Void and then not s.is_empty implies
					Result.count = s.occurrences (on) + 1
			-- and for_each s element_of Result it_holds s /= Void
		end

end
