indexing

	description: "Token and its spam probability."


class

	TOKEN_PROBABILITY


inherit

	COMPARABLE


creation

	make


feature {NONE} -- Initialization

	make (
			a_token: STRING;
			a_probability: like probability;
			a_bad_count,
			a_good_count: INTEGER) is
		require
			token_not_empty: a_token /= Void and then not a_token.is_empty
			valid_probability: a_probability >= 0 and a_probability <= 1
			bad_count_not_negative: a_bad_count >= 0
			good_count_not_negative: a_good_count >= 0
		do
			token := a_token
			probability := a_probability
			bad_count := a_bad_count
			good_count := a_good_count
		end


feature -- Access

	bad_count,
	good_count: INTEGER
			-- How often the token did occur in the bad and good learning
			-- corpus.

	token: STRING
			-- The token.

	probability: DOUBLE
			-- Probability p(w) that this token indicates spam.


feature -- Comparison

	infix "<" (other: like Current): BOOLEAN is
		do
			Result := probability < other.probability
		end


invariant

	bad_count_not_negative: bad_count >= 0
	good_count_not_negative: good_count >= 0
	token_not_empty: token /= Void and then not token.is_empty
	valid_probability: probability >= 0 and probability <= 1

end
